--- asterisk/apps/app_zapras.c	2004-06-22 21:32:52.000000000 +0200
+++ ast-fixed/apps/app_zapras.c	2005-06-23 21:17:52.000000000 +0200
@@ -125,8 +125,14 @@
 	int status;
 	int res;
 	int signalled = 0;
-	struct zt_bufferinfo bi;
+	struct zt_bufferinfo bi, savebi;
 	int x;
+	
+	res = ioctl(chan->fds[0], ZT_GET_BUFINFO, &savebi);
+	if(res) {
+		ast_log(LOG_WARNING, "Unable to check buffer policy on channel %s\n", chan->name);
+		return;
+	}
 
 	pid = spawn_ras(chan, args);
 	if (pid < 0) {
@@ -165,11 +171,11 @@
 			/* Double check buffering too */
 			res = ioctl(chan->fds[0], ZT_GET_BUFINFO, &bi);
 			if (!res) {
-				/* XXX This is ZAP_BLOCKSIZE XXX */
-				bi.bufsize = 204;
-				bi.txbufpolicy = ZT_POLICY_IMMEDIATE;
-				bi.rxbufpolicy = ZT_POLICY_IMMEDIATE;
-				bi.numbufs = 4;
+				/* Restore saved values */
+				bi.bufsize = savebi.bufsize;
+				bi.txbufpolicy = savebi.txbufpolicy;
+				bi.rxbufpolicy = savebi.rxbufpolicy;
+				bi.numbufs = savebi.numbufs;
 				res = ioctl(chan->fds[0], ZT_SET_BUFINFO, &bi);
 				if (res < 0) {
 					ast_log(LOG_WARNING, "Unable to set buffer policy on channel %s\n", chan->name);
